unit ckoptionsdialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TOptionsDialog = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    Button2: TButton;
    GroupBox2: TGroupBox;
    unit_directories: TEdit;
    Label1: TLabel;
    include_directories: TEdit;
    Label2: TLabel;
    object_directories: TEdit;
    Label3: TLabel;
    found_label: TLabel;
    install_folder: TEdit;
    Button3: TButton;
    Label4: TLabel;
    Image1: TImage;
    GroupBox3: TGroupBox;
    libccheck: TCheckBox;
    debugcheck: TCheckBox;
    tracecheck: TCheckBox;
    encodingcombo: TComboBox;
    Label5: TLabel;
    procedure install_folderChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsDialog: TOptionsDialog;

implementation

{$R *.dfm}

uses ShellAPI, shlobj;

function SearchFolder(AHandle: THandle; const ATitle: string; ANetwork: Boolean): string;
var
  browseInfo: TBrowseInfo;
  idList:     PItemIDList;
begin
  SetLength(Result, MAX_PATH);

  browseInfo.hwndOwner      := AHandle;
  browseInfo.pidlRoot       := nil;

  browseInfo.pszDisplayName := PChar(Result);
  browseInfo.lpszTitle      := PChar(ATitle);
  browseInfo.ulFlags        := (integer(not ANetWork) * BIF_DONTGOBELOWDOMAIN) or BIF_RETURNONLYFSDIRS;
  browseInfo.lpfn           := nil;
  browseInfo.lParam         := 0;
  browseInfo.iImage         := 0;

  idList := SHBrowseForFolder(browseInfo);

  if idList <> nil then
  begin
    SHGetPathFromIDList(idList, PChar(Result));
    SetLength(Result, StrLen(PChar(Result)));
  end
  else
    Result := '';
end;


procedure TOptionsDialog.install_folderChange(Sender: TObject);
begin
  if fileexists(IncludeTrailingPathDelimiter(install_folder.text)+'ck.dat') then
  begin
    found_label.caption:='OK!';
    found_label.Font.color:=clWindowText;
    if unit_directories.text='' then unit_directories.text:=IncludeTrailingPathDelimiter(install_folder.text)+'kylix\lib;';
    if include_directories.text='' then include_directories.text:=IncludeTrailingPathDelimiter(install_folder.text)+'kylix\lib;';
    if object_directories.text='' then object_directories.text:=IncludeTrailingPathDelimiter(install_folder.text)+'kylix\lib;';
  end
  else
  begin
    found_label.caption:='CrossKylix not found!';
    found_label.Font.color:=clRed;
  end;
end;

procedure TOptionsDialog.Button3Click(Sender: TObject);
var s:string;
begin
  s:=SearchFolder(application.handle, 'Browse for CrossKylix directory',false);
  if s<>'' then
  begin
    install_folder.text:=s;
    install_folderChange(self);
  end;
end;

end.
